// #autoload
// #name = Time Stamp Chat
// #version = 1.1
// #date = 15 June 2003
// #status = beta
// #author = @-Kaiten Commander
// #warrior = Kaiten Commander
// #email = kaiten@cb-tribes.co.uk
// #web = http://www.kaiten.barrysworld.net
// #description = Adds a Timestamp to the chat hud. Real or Game Time.
// #config = messageTimeStampOptions
// #include = support/mission_callbacks.cs

package messageTimeStamp
{
        function addMessageHudLine(%text)
        {	
        	if($pref::MTSEnabled)
        	{
        		if($pref::MTSGametime)
        			%text = messageGameTS()@": "@%text;
        		else
        		{
        			if($pref::MTS24hr)
        				%text = formatTimeString("HH:nn.ss")@": "@%text;
        			else
        			{
        				if($pref::MTSampm)
        				{
        					if(formatTimeString("HH") > 11)
        						%ampm = "pm";
        					else
        						%ampm = "am";
        							
        					%text = formatTimeString("hh:nn.ss")@%ampm@": "@%text;
        				}
        				else
        					%text = formatTimeString("hh:nn.ss")@": "@%text;
        			}		
        		}
        	}
        	
        	if($MTSLogging)
        		messageTimeStampLogger(%text);
        	
        	parent::addMessageHudLine(%text);
        }
        
	function OptionsDlg::onWake( %this )
	{
		if(!$messageTimeStampBind)
		{
        		$RemapName[$RemapCount]="Time Stamp Chat";
        		$RemapCmd[$RemapCount]="messageTimeStampBind";
        		$RemapCount++;
        		$RemapName[$RemapCount]="Time Stamp Log";
        		$RemapCmd[$RemapCount]="messageTimeStampLog";
        		$RemapCount++;
		
			$messageTimeStampBind = true;
   		}
   		parent::onWake( %this );
	}
	
	function clientCmdSetPilotVehicleKeys()
	{
		passengerKeys.copyBind( moveMap, messageTimeStampBind);
		passengerKeys.copyBind( moveMap, messageTimeStampLog);
	 	parent::clientCmdSetPilotVehicleKeys();
	}

	function clientCmdSetPassengerVehicleKeys()
	{
		passengerKeys.copyBind( moveMap, messageTimeStampBind);
		passengerKeys.copyBind( moveMap, messageTimeStampLog);
		parent::clientCmdSetPassengerVehicleKeys();
	}	      
        
};
activatePackage(messageTimeStamp);

function messageTimeStampBind(%val)
{
	if(%val)
	{
		$pref::MTSType++;
		if($pref::MTSType == 4)
		      $pref::MTSType = 1;
		
		switch$ ($pref::MTSType)
         	{
			case 1:
				$pref::MTSEnabled = 0;
				addmessageHudline("Time Stamp - Off");
			case 2:
				$pref::MTSEnabled = 1;
				$pref::MTSGametime = 1;
				addmessageHudline("Time Stamp - Game Time");
			case 3:
				$pref::MTSEnabled = 1;
				$pref::MTSGametime = 0;
				addmessageHudline("Time Stamp - Real Time");
		}			
	}		
}

function messageTimeStampLog(%val)
{
	if(%val)
	{
		$pref::MTSLog = !$pref::MTSLog;
		if($pref::MTSLog)
		{
			$MTSLogging = 1;
			$MTSChatLog = messageTimeStampGetName();
			addmessageHudline("Logging Chat - "@$MTSChatLog);
		}
		else
		{
			$MTSLogging = 0;
			addmessageHudline("Stopped Logging Chat - "@$MTSChatLog);
		}	
	}		
}

function messageTimeStampGetName()
{
	
	for(%i = 0; %i < 1000; %i++)
	{
		%num = %i;
		if(%num < 10)
			%num = "0" @ %num;
		if(%num < 100)
			%num = "0" @ %num;
		%file = "chatlog/"@$clMissionName@"-"@formatTimeString("dd-mm-yy")@"-"@%num@".log";
		if(!isfile(%file))
			break;
	}
	if(%i == 1000)
		return;

   	return %file;
}

  
function messageTimeStampLogger(%text)
{
	if($MTSChatLog $= "")
	{
		$MTSChatLog = messageTimeStampGetName();
		addmessageHudline("Logging Chat - "@$MTSChatLog);
	}	
	
	%text = stripChars( %text, "\cp\co\c6\c7\c8\c9\c0\c1\c2\c3\c4\c5" );
	
	if(!isObject(%MTSFile))
        	%MTSFile = new FileObject();
        
        %MTSFile.openforAppend($MTSChatLog);
        %MTSFile.writeline(%text);
        %MTSFile.close();
}

function messageGameTS()
{
	%timeleft = clockHUD.gettime();
	%msecs = %timeleft * 60000;
	%minute = (mfloor(%msecs/1000/60) - (mfloor(%msecs/1000/60/60) * 60));
	%second = mfloor(%msecs/1000) - (mfloor(%msecs/1000/60)*60);

	if(%second < 10)
		%second = "0" @ %second;
		
	if(%minute < 10)
		%minute = "0" @ %minute;

     	return %minute @ ":" @ %second;
}

function messageTimeStampOptions::onWake(%this)
{
	MTSLogPopup.clear();
	MTSLogPopup.settext("Select Logfile");
	
	%search = "chatlog/*.log";
	%count = 1;
	for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search))
	{
		%fileName = fileBase(%file);
		MTSLogPopup.add(%fileName, %count);
		%count++;
	}
	MTSLogPopup.sort( true );
}

function MTSLogPopup::onSelect(%this, %id, %text)
{
	%file = new FileObject();
	MTSLogText.setValue( %file.getContents("chatlog/"@%text@".log"));
       	%file.close();
       	%file.delete();
}

if (!isObject(messageTimeStampOptions))
{
	new GuiControl(messageTimeStampOptions) {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = "640 480";
		minExtent = "300 315";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "height";
			position = "10 12";
			extent = "115 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$pref::MTS24hr";
			helpTag = "0";
			text = "24 Hours";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "height";
			position = "129 12";
			extent = "115 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$pref::MTSampm";
			helpTag = "0";
			text = "Show AM/PM";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "height";
			position = "247 12";
			extent = "115 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$pref::MTSEnabled";
			helpTag = "0";
			text = "Enabled";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(MTSLogPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "5 39";
			extent = "368 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellScrollCtrl() {
			profile = "NewScrollCtrlProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "5 75";
			extent = "380 270";
			minExtent = "24 24";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			willFirstRespond = "1";
			hScrollBar = "alwaysOff";
			vScrollBar = "alwaysOn";
			constantThumbHeight = "0";
			defaultLineHeight = "15";
			childMargin = "3 3";
			fieldBase = "gui/shll_field";

			new GuiScrollContentCtrl() {
				profile = "GuiDefaultProfile";
				horizSizing = "width";
				vertSizing = "height";
				position = "7 7";
				extent = "350 254";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";

				new GuiMLTextEditCtrl(MTSLogText) {
					profile = "DebriefTextProfile";
					horizSizing = "width";
					vertSizing = "height";
					position = "0 0";
					extent = "390 254";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					lineSpacing = "2";
					allowColorChars = "1";
					maxChars = "-1";
					deniedSound = "InputDeniedSound";
				};
			};
		};
	};
}

function messageTimeStampGameOver()
{
	if($pref::MTSLog)
	{
		$MTSLogging = 0;
		$MTSChatLog = "";
	}	
}

function messageTimeStampUserJoined()
{
	if($pref::MTSLog)
		$MTSLogging = 1;
}

Callback.add(onGameOver,"messageTimeStampGameOver();");
Callback.add(onUserClientDrop,"messageTimeStampGameOver();");
callback.add(onMissionDropInfo,"messageTimeStampUserJoined();");	